/* this is an artificial program that creates many threads */
parse upper arg option rounds
if option<>"" then .traceObject~option=option
say ".traceObject~option:" .traceObject~option
if rounds="" then rounds=1

do counter c rounds
   say "round #" c"/"rounds
   obj=.demoMT~new
      -- from now on send messages asynchroneously (on separate threads)
   obj~~start("mg")~~start("mu")~~start("bumpCtlAttribute")
   msg=.message~new(obj,"bumpCtlAttribute")  -- message to send later
   waitTime=.timeSpan~fromLongTime("00:00:0" || random(15,25)/1000)  -- wait a few msecs
      -- commenting the following two statements will cause deadlocks
   .alarm~new(waitTime, msg)  -- send message after waitTime, will unblock
   .alarm~new(waitTime, msg)  -- send message after waitTime, will unblock
end

::class "demoMT"        -- a class for experimenting with threads

::method init           -- guarded method
  expose ctlAttribute
  ctlAttribute=random(0,125)/1000   -- add some randomness

::method bumpCtlAttribute unguarded -- unguarded method
  expose ctlAttribute
  TRACE n               -- set trace to normal (in method "bumpCtlAttribute")
  do 50                 -- change value of ctlAttribute 50 times
     ctlAttribute=random(100,250)/1000 -- add some randomness
  end
  ctlAttribute=1        -- make sure a value that unblocks
  say .line "ctlAttribute="ctlAttribute

::method mg             -- guarded method
  expose ctlAttribute
  guard off                         -- guard off
  reply           -- return, remainder on new thread
  guard on  when ctlAttribute>0.250 -- guard on
  ctlAttribute=random(0,125)/1000   -- add some randomness
  call sysSleep random(1,10)/1000   -- add some randomness
  guard off when ctlAttribute>0.250 -- guard off
  ctlAttribute=random(0,125)/1000   -- add some randomness
  say .context~name": returning ..."

::method mu unguarded   -- unguarded method
  expose ctlAttribute
  guard on                          -- guard on
  reply           -- return, remainder on new thread
  guard off when ctlAttribute>0.250 -- guard off
  ctlAttribute=random(0,125)/1000   -- add some randomness
  guard on  when ctlAttribute>0.250 -- guard on
  call sysSleep random(1,10)/1000   -- add some randomness
  say .context~name": returning ..."

::options trace r
