/* a test program, employing guarded and unguarded methods, 20240129, rgf */
-- based on test02.rex: demonstrates usefulness of 'F' compared to 'S' (and 'N' of course)
thisName="(".context~name")"  -- package
say "before creating instance of .oha" thisName -- package
o1=.oha~new -- package
o2=.oha~new -- package
say "o="o thisName -- package

o1~m_22   -- package
o1~m_0    -- package
o2~m_0    -- package
o2~m_22   -- package
o1~m_22   -- package

exit -- package

::class oha
::method init
  thisName="(".context~name")"   -- INIT GUARDED

::method m_0
  thisName="(".context~name")" -- m_0 GUARDED
  self~m_1 -- m_0

::method m_1
  thisName="(".context~name")" -- m_1 GUARDED
  reply  -- m_1: remainder runs on new thread -- m_1
  guard off  -- m_1
  sleepTime=random(1, 10)/1000 -- m_1
  call sysSleep sleepTime -- m_1
  guard on -- m_1

::method m_22 unguarded
  thisName="(".context~name")" -- m_22 UNGUARDED
  reply  -- m_22: remainder runs on new thread -- m_22
  guard on -- m_22
  sleepTime=random(1, 10)/1000 -- m_22
  call sysSleep sleepTime      -- m_22
  guard off                    -- m_22


::method m_333
  thisName="(".context~name")" -- m_333 GUARDED
  reply  -- m_333: remainder runs on new thread
  /* some comm */ nop; /* go */ guard off /* go */; nop   -- m_333
  sleepTime=random(1, 10)/1000   -- m_333
  call sysSleep sleepTime        -- m_333
  nop; guard on; nop             -- m_333

::options trace a
-- ::options trace labels
